Loading...
Searching...
No Matches
casacore::CompressComplexSD Class Reference
tables package (libcasa_tables) » DataMan_module

Virtual column engine to scale a table Complex array for Single Dish data. More...

`#include <CompressComplex.h>`

## Public Member Functions

| CompressComplexSD (const String &virtualColumnName, const String &storedColumnName, Float scale, Float offset=0)
| Construct an engine to scale all arrays in a column with the given offset and scale factor.
| CompressComplexSD (const String &virtualColumnName, const String &storedColumnName, const String &scaleColumnName, const String &offsetColumnName, Bool autoScale=True)
| Construct an engine to scale the arrays in a column.
| CompressComplexSD (const Record &spec)
| Construct from a record specification as created by getmanagerSpec().
| ~CompressComplexSD ()
| Destructor is mandatory.
CompressComplexSD & | operator= (const CompressComplexSD &)=delete
| Assignment is not needed and therefore forbidden.
virtual String | dataManagerType () const
| Return the type name of the engine (i.e.
Public Member Functions inherited from casacore::CompressComplex
| CompressComplex (const String &virtualColumnName, const String &storedColumnName, Float scale, Float offset=0)
| Construct an engine to scale all arrays in a column with the given offset and scale factor.
| CompressComplex (const String &virtualColumnName, const String &storedColumnName, const String &scaleColumnName, const String &offsetColumnName, Bool autoScale=True)
| Construct an engine to scale the arrays in a column.
| CompressComplex (const Record &spec)
| Construct from a record specification as created by getmanagerSpec().
| ~CompressComplex ()
| Destructor is mandatory.
CompressComplex & | operator= (const CompressComplex &)=delete
| Assignment is not needed and therefore forbidden.
virtual String | dataManagerName () const
| Get the name given to the engine (is the virtual column name).
virtual Record | dataManagerSpec () const
| Record a record containing data manager specifications.
Public Member Functions inherited from casacore::BaseMappedArrayEngine< Complex, Int >
const String & | virtualName () const
| Get the virtual column name.
const String & | storedName () const
| Get the stored column name.
virtual Bool | isWritable () const
| The column is writable if the underlying stored column is writable.
Public Member Functions inherited from casacore::VirtualColumnEngine
| VirtualColumnEngine ()
| Create the object.
virtual | ~VirtualColumnEngine ()
| VirtualColumnEngine (const VirtualColumnEngine &)=delete
| The copy constructor cannot be used for this base class.
VirtualColumnEngine & | operator= (const VirtualColumnEngine &)=delete
| Assignment cannot be used for this base class.
Public Member Functions inherited from casacore::DataManager
| DataManager ()
| Default constructor.
virtual | ~DataManager ()
| DataManager (const DataManager &)=delete
| The copy constructor cannot be used for this base class.
DataManager & | operator= (const DataManager &)=delete
| Assignment cannot be used for this base class.
void | dataManagerInfo (Record &info) const
| Add SEQNR and SPEC (the DataManagerSpec subrecord) to the info.
virtual Record | getProperties () const
| Get data manager properties that can be modified.
virtual void | setProperties (const Record &spec)
| Modify data manager properties given in record fields.
virtual Bool | canReallocateColumns () const
| Tell if the data manager wants to reallocate the data manager column objects.
virtual DataManagerColumn * | reallocateColumn (DataManagerColumn *column)
| Reallocate the column object if it is part of this data manager.
uInt | sequenceNr () const
| Get the (unique) sequence nr of this data manager.
uInt | ncolumn () const
| Get the nr of columns in this data manager (can be zero).
Bool | asBigEndian () const
| Have the data to be stored in big or little endian canonical format?
const TSMOption & | tsmOption () const
| Get the TSM option.
std::shared_ptr< MultiFileBase > | multiFile ()
| Get the MultiFile pointer (can be 0).
String | keywordName (const String &keyword) const
| Compose a keyword name from the given keyword appended with the sequence number (e.g.
String | fileName () const
| Compose a unique filename from the table name and sequence number.
ByteIO::OpenOption | fileOption () const
| Get the AipsIO option of the underlying file.
virtual Bool | isRegular () const
| Is this a regular storage manager?
Table & | table () const
| Get the table this object is associated with.
virtual Bool | canAddColumn () const
| Does the data manager allow to add columns?
virtual Bool | canRemoveColumn () const
| Does the data manager allow to delete columns?
virtual Bool | canRenameColumn () const
| Does the data manager allow to rename columns?
virtual void | setMaximumCacheSize (uInt nMiB)
| Set the maximum cache size (in bytes) to be used by a storage manager.
virtual void | showCacheStatistics (std::ostream &) const
| Show the data manager's IO statistics.
DataManagerColumn * | createScalarColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a column in the data manager on behalf of a table column.
DataManagerColumn * | createDirArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create a direct array column.
DataManagerColumn * | createIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create an indirect array column.
DataManager * | getClone () const
| Has the object already been cloned?
void | setClone (DataManager *clone) const
| Set the pointer to the clone.
Public Member Functions inherited from casacore::VirtualArrayColumn< Complex >
| VirtualArrayColumn ()
| Create a column.
virtual | ~VirtualArrayColumn ()
VirtualArrayColumn< Complex > & | operator= (const VirtualArrayColumn< Complex > &)=delete
| The object cannot be assigned to.
virtual int | dataType () const
| Return the data type of the column.
virtual String | dataTypeId () const
| Return the data type Id of the column.
Public Member Functions inherited from casacore::VirtualArrayColumnBase
| VirtualArrayColumnBase ()
| Create a column.
virtual | ~VirtualArrayColumnBase ()
Public Member Functions inherited from casacore::DataManagerColumn
| DataManagerColumn ()
| Create a column.
virtual | ~DataManagerColumn ()
| Frees up the storage.
| DataManagerColumn (const DataManagerColumn &)=delete
| The copy constructor cannot be used for this base class.
DataManagerColumn & | operator= (const DataManagerColumn &)=delete
| Assignment cannot be used for this base class.
void | setIsFixedShape (Bool isFixedShape)
| Set the isFixedShape flag.
Bool | isFixedShape () const
| Is this a fixed shape column?
virtual void | setMaxLength (uInt maxLength)
| Set the maximum length of the value (can be used for strings).
void | setFixedShapeColumn (const IPosition &shape)
| Set the shape of all (fixed-shaped) arrays in the column.
virtual void | setShapeTiled (rownr_t rownr, const IPosition &shape, const IPosition &tileShape)
| Set the shape and tile shape of an (variable-shaped) array in the given row.
virtual IPosition | tileShape (rownr_t rownr)
| Get the tile shape of the item in the given row.
ColumnCache & | columnCache ()
| Get access to the ColumnCache object.
const ColumnCache * | columnCachePtr () const
void | get (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
void | get (rownr_t rownr, uChar *dataPtr)
void | get (rownr_t rownr, Short *dataPtr)
void | get (rownr_t rownr, uShort *dataPtr)
void | get (rownr_t rownr, Int *dataPtr)
void | get (rownr_t rownr, uInt *dataPtr)
void | get (rownr_t rownr, Int64 *dataPtr)
void | get (rownr_t rownr, float *dataPtr)
void | get (rownr_t rownr, double *dataPtr)
void | get (rownr_t rownr, Complex *dataPtr)
void | get (rownr_t rownr, DComplex *dataPtr)
void | get (rownr_t rownr, String *dataPtr)
void | get (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
void | put (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
void | put (rownr_t rownr, const uChar *dataPtr)
void | put (rownr_t rownr, const Short *dataPtr)
void | put (rownr_t rownr, const uShort *dataPtr)
void | put (rownr_t rownr, const Int *dataPtr)
void | put (rownr_t rownr, const uInt *dataPtr)
void | put (rownr_t rownr, const Int64 *dataPtr)
void | put (rownr_t rownr, const float *dataPtr)
void | put (rownr_t rownr, const double *dataPtr)
void | put (rownr_t rownr, const Complex *dataPtr)
void | put (rownr_t rownr, const DComplex *dataPtr)
void | put (rownr_t rownr, const String *dataPtr)
void | put (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | throwGet () const
| Throw an "invalid operation" exception for the default implementation of get.
void | throwPut () const
| Throw an "invalid operation" exception for the default implementation of put.
void | setColumnName (const String &colName)
| Set the column name.
const String & | columnName () const
| Get rhe column name.

## Static Public Member Functions

static String | className ()
| Return the name of the class.
static void | registerClass ()
| Register the class name and the static makeObject "constructor".
static DataManager * | makeObject (const String &dataManagerType, const Record &spec)
| Define the "constructor" to construct this engine when a table is read back.
Static Public Member Functions inherited from casacore::CompressComplex
static String | className ()
| Return the name of the class.
static void | registerClass ()
| Register the class name and the static makeObject "constructor".
static DataManager * | makeObject (const String &dataManagerType, const Record &spec)
| Define the "constructor" to construct this engine when a table is read back.
Static Public Member Functions inherited from casacore::DataManager
static void | registerCtor (const String &type, DataManagerCtor func)
| Register a mapping of a data manager type to its static construction function.
static DataManagerCtor | getCtor (const String &dataManagerType)
| Get the "constructor" of a data manager (thread-safe).
static Bool | isRegistered (const String &dataManagerType)
| Test if a data manager is registered (thread-safe).
static DataManager * | unknownDataManager (const String &dataManagerType, const Record &spec)
| Serve as default function for theirRegisterMap, which catches all unknown data manager types.

## Private Member Functions

| CompressComplexSD (const CompressComplexSD &)
| Copy constructor is only used by clone().
virtual DataManager * | clone () const
| Clone the engine object.
virtual void | create64 (rownr_t initialNrrow)
| Initialize the object for a new table.
virtual void | scaleOnGet (Float scale, Float offset, Array< Complex > &array, const Array< Int > &target)
| Scale and/or offset target to array.
virtual void | scaleOnPut (Float scale, Float offset, const Array< Complex > &array, Array< Int > &target)
| Scale and/or offset array to target.
virtual void | findMinMax (Float &minVal, Float &maxVal, const Array< Complex > &array) const
| Find minimum and maximum from the array data.

## Additional Inherited Members

Static Public Attributes inherited from casacore::DataManager
static rownr_t | MAXROWNR32
| Define the highest row number that can be represented as signed 32-bit.
Protected Member Functions inherited from casacore::CompressComplex
| CompressComplex (const CompressComplex &)
| Copy constructor is only used by clone() and derived class.
Float | getScale (rownr_t rownr)
| Get the scale value for this row.
Float | getOffset (rownr_t rownr)
| Get the offset value for this row.
void | makeScaleOffset (Float &scale, Float &offset, Float minVal, Float maxVal) const
| Make scale and offset from the minimum and maximum of the array data.
void | putPart (rownr_t rownr, const Slicer &slicer, const Array< Complex > &array, Float scale, Float offset)
| Put a part of an array in a row using given scale/offset values.
void | putFullPart (rownr_t rownr, const Slicer &slicer, Array< Complex > &fullArray, const Array< Complex > &partArray, Float minVal, Float maxVal)
| Fill the array part into the full array and put it using the given min/max values.
Protected Member Functions inherited from casacore::BaseMappedArrayEngine< Complex, Int >
| BaseMappedArrayEngine (const String &virtualColumnName, const String &storedColumnName)
| Construct an engine to convert the virtual column to the stored column.
| ~BaseMappedArrayEngine ()
| Destructor is mandatory.
BaseMappedArrayEngine & | operator= (const BaseMappedArrayEngine &)=delete
| Assignment is not needed and therefore forbidden.
void | setWritable (Bool isWritable)
| Set if the column is writable or not.
void | setNames (const String &virtualName, const String &storedName)
| Set the virtual and stored column name.
ArrayColumn< Int > & | column ()
| Give access to the stored column.
virtual DataManagerColumn * | makeIndArrColumn (const String &columnName, int dataType, const String &dataTypeId)
| Create the column object for the array column in this engine.
void | prepare1 ()
| Do the 2 stages of the prepare (define columns and adding rows).
void | prepare2 ()
virtual void | addRow64 (rownr_t nrrow)
| Rows are added to the end of the table.
virtual void | setShapeColumn (const IPosition &shape)
| Set the shape of the FixedShape arrays in the column.
virtual void | setShape (rownr_t rownr, const IPosition &shape)
| Define the shape of the array in the given row.
virtual Bool | isShapeDefined (rownr_t rownr)
| Test if the (underlying) array is defined in the given row.
virtual uInt | ndim (rownr_t rownr)
| Get the dimensionality of the (underlying) array in the given row.
virtual IPosition | shape (rownr_t rownr)
| Get the shape of the (underlying) array in the given row.
virtual Bool | canChangeShape () const
| The data manager can handle changing the shape of an existing array when the underlying stored column can do it.
TableColumn | makeTableColumn (const String &columnName)
| Make a table column object for the given column.
virtual IPosition | getStoredShape (rownr_t rownr, const IPosition &virtualShape)
| Map the virtual shape to the stored shape.
virtual Slicer | getStoredSlicer (const Slicer &virtualSlicer) const
| Map the slicer for a virtual shape to a stored shape.
virtual void | mapOnGet (Array< Complex > &array, const Array< Int > &stored)
| Map StoredType array to VirtualType array.
virtual void | mapOnPut (const Array< Complex > &array, Array< Int > &stored)
| Map Bool array to bit flags array.
Protected Member Functions inherited from casacore::DataManager
void | decrementNcolumn ()
| Decrement number of columns (in case a column is deleted).
void | setEndian (Bool bigEndian)
| Tell the data manager if big or little endian format is needed.
void | setTsmOption (const TSMOption &tsmOption)
| Tell the data manager which TSM option to use.
void | setMultiFile (const std::shared_ptr< MultiFileBase > &mfile)
| Tell the data manager that MultiFile can be used.
virtual Bool | hasMultiFileSupport () const
| Does the data manager support use of MultiFile?
void | throwDataTypeOther (const String &columnName, int dataType) const
| Throw an exception in case data type is TpOther, because the storage managers (and maybe other data managers) do not support such columns.
Protected Member Functions inherited from casacore::VirtualArrayColumnBase
virtual void | getScalarColumnV (ArrayBase &dataPtr)
| The scalar access functions throw an exception.
virtual void | putScalarColumnV (const ArrayBase &dataPtr)
| Put all scalar values in the column.
virtual void | getScalarColumnCellsV (const RefRows &rownrs, ArrayBase &dataPtr)
| Get some scalar values in the column.
virtual void | putScalarColumnCellsV (const RefRows &rownrs, const ArrayBase &dataPtr)
| Put some scalar values in the column.
Protected Member Functions inherited from casacore::DataManagerColumn
virtual void | getBool (rownr_t rownr, Bool *dataPtr)
| Get the scalar value in the given row.
virtual void | getuChar (rownr_t rownr, uChar *dataPtr)
virtual void | getShort (rownr_t rownr, Short *dataPtr)
virtual void | getuShort (rownr_t rownr, uShort *dataPtr)
virtual void | getInt (rownr_t rownr, Int *dataPtr)
virtual void | getuInt (rownr_t rownr, uInt *dataPtr)
virtual void | getInt64 (rownr_t rownr, Int64 *dataPtr)
virtual void | getfloat (rownr_t rownr, float *dataPtr)
virtual void | getdouble (rownr_t rownr, double *dataPtr)
virtual void | getComplex (rownr_t rownr, Complex *dataPtr)
virtual void | getDComplex (rownr_t rownr, DComplex *dataPtr)
virtual void | getString (rownr_t rownr, String *dataPtr)
virtual void | getOther (rownr_t rownr, void *dataPtr)
| This function is the get for all non-standard data types.
virtual void | putBool (rownr_t rownr, const Bool *dataPtr)
| Put the scalar value into the given row.
virtual void | putuChar (rownr_t rownr, const uChar *dataPtr)
virtual void | putShort (rownr_t rownr, const Short *dataPtr)
virtual void | putuShort (rownr_t rownr, const uShort *dataPtr)
virtual void | putInt (rownr_t rownr, const Int *dataPtr)
virtual void | putuInt (rownr_t rownr, const uInt *dataPtr)
virtual void | putInt64 (rownr_t rownr, const Int64 *dataPtr)
virtual void | putfloat (rownr_t rownr, const float *dataPtr)
virtual void | putdouble (rownr_t rownr, const double *dataPtr)
virtual void | putComplex (rownr_t rownr, const Complex *dataPtr)
virtual void | putDComplex (rownr_t rownr, const DComplex *dataPtr)
virtual void | putString (rownr_t rownr, const String *dataPtr)
virtual void | putOther (rownr_t rownr, const void *dataPtr)
| This function is the put for all non-standard data types.
void | getScalarColumnBase (ArrayBase &dataPtr)
| The default implementations of get and put functions.
void | putScalarColumnBase (const ArrayBase &dataPtr)
void | getScalarColumnCellsBase (const RefRows &rownrs, ArrayBase &dataPtr)
void | putScalarColumnCellsBase (const RefRows &rownrs, const ArrayBase &dataPtr)
void | getArrayColumnBase (ArrayBase &data)
void | putArrayColumnBase (const ArrayBase &data)
void | getArrayColumnCellsBase (const RefRows &rownrs, ArrayBase &data)
void | putArrayColumnCellsBase (const RefRows &rownrs, const ArrayBase &data)
void | getSliceBase (rownr_t rownr, const Slicer &slicer, ArrayBase &data)
void | putSliceBase (rownr_t rownr, const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceBase (const Slicer &slicer, ArrayBase &data)
void | putColumnSliceBase (const Slicer &slicer, const ArrayBase &data)
void | getColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, ArrayBase &data)
void | putColumnSliceCellsBase (const RefRows &rownrs, const Slicer &slicer, const ArrayBase &data)
Protected Attributes inherited from casacore::CompressComplex
String | scaleName_p
String | offsetName_p
Float | scale_p
Float | offset_p
Bool | fixed_p
Bool | autoScale_p
ScalarColumn< Float > * | scaleColumn_p
ScalarColumn< Float > * | offsetColumn_p
Array< Int > | buffer_p

## Detailed Description

Virtual column engine to scale a table Complex array for Single Dish data.

### Intended use:

Public interface

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25
Test programs:
  tCompressComplex

### Prerequisite

- CompressComplex

### Synopsis

CompressComplexSD is similar to CompressComplex, but compresses in a slighty different way optimized for single dish data. Usually the imaginary part of single dish data is 0, so the scaling is optimized for it.
If the imaginary part is 0, the real part is scaled with 15 bits extra to get a higher precision. The least significant bit is set to 0 indicating the imag==0.
If the imaginary part is not 0, the real part is scaled normally. The imaginary part is scaled with 1 bit less. The least significant bit is set to 1 indicating that imag!=0.

### Motivation

This class is created on top of CompressComplex to cope with SD data in a better way. Using CompressComplex often makes the imag part non-zero if it is scaled as 0.

### Example

// Create the table description and 2 columns with indirect arrays in it.
// The Int column will be stored, while the double will be
// used as virtual.
TableDesc tableDesc ("", TableDesc::Scratch);
tableDesc.addColumn (ArrayColumnDesc<Int> ("storedArray"));
tableDesc.addColumn (ArrayColumnDesc<Complex> ("virtualArray"));
tableDesc.addColumn (ScalarColumnDesc<Complex> ("scale"));
tableDesc.addColumn (ScalarColumnDesc<Float> ("offset"));
// Create a new table using the table description.
SetupNewTable newtab (tableDesc, "tab.data", Table::New);
// Create the array scaling engine (with auto-scale)
// and bind it to the Complex column.
CompressComplexSD scalingEngine("virtualArray", "storedArray",
"scale", "offset");
newtab.bindColumn ("virtualArray", scalingEngine);
// Create the table.
Table table (newtab);
// Store a 3-D array (with dim. 2,3,4) into each row of the column.
// The shape of each array in the column is implicitly set by the put
// function. This will also set the shape of the underlying Int array.
ArrayColumn data (table, "virtualArray");
Array<double> someArray(IPosition(4,2,3,4));
someArray = 0;
for (rownr_t i=0, i<10; i++) { // table will have 10 rows
table.addRow();
data.put (i, someArray)
}
casacore::ArrayColumnDesc
Templated class for description of table array columns.
Definition ArrColDesc.h:235
casacore::ArrayColumn
Definition ArrayColumn.h:98
casacore::Array
Definition Array.h:155
casacore::CompressComplexSD::CompressComplexSD
CompressComplexSD(const String &virtualColumnName, const String &storedColumnName, Float scale, Float offset=0)
Construct an engine to scale all arrays in a column with the given offset and scale factor.
casacore::DataManager::table
Table & table() const
Get the table this object is associated with.
Definition DataManager.h:323
casacore::IPosition
Definition IPosition.h:117
casacore::ScalarColumnDesc
Definition ScaColDesc.h:162
casacore::SetupNewTable
Create a new table - define shapes, data managers, etc.
Definition SetupNewTab.h:337
casacore::TableDesc
Definition TableDesc.h:189
casacore::TableDesc::Scratch
@ Scratch
Definition TableDesc.h:193
casacore::Table
Definition Table.h:157
casacore::Table::New
@ New
create table
Definition Table.h:175
casacore::rownr_t
uInt64 rownr_t
Define the type of a row number in a table.
Definition aipsxtype.h:44

Definition at line 432 of file CompressComplex.h.

## Constructor & Destructor Documentation

## CompressComplexSD() [1/4]

casacore::CompressComplexSD::CompressComplexSD | ( | const String & | virtualColumnName,
|  | const String & | storedColumnName,
|  | Float | scale,
|  | Float | offset = 0 )

Construct an engine to scale all arrays in a column with the given offset and scale factor.

StoredColumnName is the name of the column where the scaled data will be put and must have data type Int. The virtual column using this engine must have data type Complex.

References casacore::offset().

Referenced by CompressComplexSD(), and operator=().

## CompressComplexSD() [2/4]

casacore::CompressComplexSD::CompressComplexSD | ( | const String & | virtualColumnName,
|  | const String & | storedColumnName,
|  | const String & | scaleColumnName,
|  | const String & | offsetColumnName,
|  | Bool | autoScale = True )

Construct an engine to scale the arrays in a column.

The scale and offset values are taken from a column with the given names. In that way each array has its own scale factor and offset value. An exception is thrown if these columns do not exist. VirtualColumnName is the name of the virtual column and is used to check if the engine gets bound to the correct column. StoredColumnName is the name of the column where the scaled data will be put and must have data type Int. The virtual column using this engine must have data type Complex.

References casacore::True.

## CompressComplexSD() [3/4]

casacore::CompressComplexSD::CompressComplexSD | ( | const Record & | spec | ) |

Construct from a record specification as created by getmanagerSpec().

References casacore::Record().

## ~CompressComplexSD()

casacore::CompressComplexSD::~CompressComplexSD | ( |  | ) |

Destructor is mandatory.

## CompressComplexSD() [4/4]

casacore::CompressComplexSD::CompressComplexSD | ( | const CompressComplexSD & |  | ) |

private

Copy constructor is only used by clone().

(so it is made private).

References CompressComplexSD().

## Member Function Documentation

## className()

String casacore::CompressComplexSD::className | ( |  | ) |

static

Return the name of the class.

This includes the names of the template arguments.

## clone()

virtual DataManager * casacore::CompressComplexSD::clone | ( |  | ) | const

private virtual

Clone the engine object.

Reimplemented from casacore::CompressComplex.

## create64()

virtual void casacore::CompressComplexSD::create64 | ( | rownr_t | initialNrrow | ) |

private virtual

Initialize the object for a new table.

It defines the keywords containing the engine parameters.

Reimplemented from casacore::CompressComplex.

## dataManagerType()

virtual String casacore::CompressComplexSD::dataManagerType | ( |  | ) | const

virtual

Return the type name of the engine (i.e.

its class name).

Reimplemented from casacore::CompressComplex.

Referenced by makeObject().

## findMinMax()

virtual void casacore::CompressComplexSD::findMinMax | ( | Float & | minVal,
|  | Float & | maxVal,
|  | const Array< Complex > & | array ) const

private virtual

Find minimum and maximum from the array data.

NaN and infinite values and zero imaginary parts are ignored. If no values are finite, minimum and maximum are set to NaN.

Reimplemented from casacore::CompressComplex.

References casacore::array.

## makeObject()

DataManager * casacore::CompressComplexSD::makeObject | ( | const String & | dataManagerType,
|  | const Record & | spec )

static

Define the "constructor" to construct this engine when a table is read back.

This "constructor" has to be registered by the user of the engine. If the engine is commonly used, its registration can be added to the registerAllCtor function in DataManager.cc. That function gets automatically invoked by the table system.

References dataManagerType(), and casacore::Record().

## operator=()

CompressComplexSD & casacore::CompressComplexSD::operator= | ( | const CompressComplexSD & |  | ) |

delete

Assignment is not needed and therefore forbidden.

References CompressComplexSD().

## registerClass()

void casacore::CompressComplexSD::registerClass | ( |  | ) |

static

Register the class name and the static makeObject "constructor".

This will make the engine known to the table system.

## scaleOnGet()

virtual void casacore::CompressComplexSD::scaleOnGet | ( | Float | scale,
|  | Float | offset,
|  | Array< Complex > & | array,
|  | const Array< Int > & | target )

private virtual

Scale and/or offset target to array.

This is meant when reading an array from the stored column. It optimizes for scale=1 and/or offset=0.

Reimplemented from casacore::CompressComplex.

References casacore::array, and casacore::offset().

## scaleOnPut()

virtual void casacore::CompressComplexSD::scaleOnPut | ( | Float | scale,
|  | Float | offset,
|  | const Array< Complex > & | array,
|  | Array< Int > & | target )

private virtual

Scale and/or offset array to target.

This is meant when writing an array into the stored column. It optimizes for scale=1 and/or offset=0.

Reimplemented from casacore::CompressComplex.

References casacore::array, and casacore::offset().

The documentation for this class was generated from the following file:

- tables/DataMan/CompressComplex.h